/*
 * Copyright 2010 Google Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except
 * in compliance with the License. You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License
 * is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express
 * or implied. See the License for the specific language governing permissions and limitations under
 * the License.
 */
/*
 * Warning! This file is generated. Modify at your own risk.
 */

package com.google.api.services.groupssettings.model;

import com.google.api.client.json.GenericJson;

/**
 * JSON template for Group resource
 *
 * <p> This is the Java data model class that specifies how to parse/serialize into the JSON that is
 * transmitted over HTTP when working with the Groups Settings API. For a detailed explanation see:
 * <a href="http://code.google.com/p/google-api-java-client/wiki/Json">http://code.google.com/p/google-api-java-client/wiki/Json</a>
 * </p>
 *
 * <p>
 * Upgrade warning: starting with version 1.12 {@code getResponseHeaders()} is removed, instead use
 * {@link com.google.api.client.http.json.JsonHttpRequest#getLastResponseHeaders()}
 * </p>
 *
 * @author Google, Inc.
 */
@SuppressWarnings("javadoc")
public final class Groups extends GenericJson {

  /**
   * Are external members allowed to join the group.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private String allowExternalMembers;

  /**
   * Is google allowed to contact admins.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private String allowGoogleCommunication;

  /**
   * If posting from web is allowed.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private String allowWebPosting;

  /**
   * If the group is archive only
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private String archiveOnly;

  /**
   * Default email to which reply to any message should go.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private String customReplyTo;

  /**
   * Default message deny notification message
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private String defaultMessageDenyNotificationText;

  /**
   * Description of the group
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private String description;

  /**
   * Email id of the group
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private String email;

  /**
   * If this groups should be included in global address list or not.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private String includeInGlobalAddressList;

  /**
   * If the contents of the group are archived.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private String isArchived;

  /**
   * The type of the resource.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private String kind;

  /**
   * Maximum message size allowed.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private Integer maxMessageBytes;

  /**
   * Can members post using the group email address.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private String membersCanPostAsTheGroup;

  /**
   * Default message display font. Possible values are: DEFAULT_FONT FIXED_WIDTH_FONT
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private String messageDisplayFont;

  /**
   * Moderation level for messages. Possible values are: MODERATE_ALL_MESSAGES MODERATE_NON_MEMBERS
   * MODERATE_NEW_MEMBERS MODERATE_NONE
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private String messageModerationLevel;

  /**
   * Name of the Group
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private String name;

  /**
   * Primary language for the group.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private String primaryLanguage;

  /**
   * Whome should the default reply to a message go to. Possible values are: REPLY_TO_CUSTOM
   * REPLY_TO_SENDER REPLY_TO_LIST REPLY_TO_OWNER REPLY_TO_IGNORE REPLY_TO_MANAGERS
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private String replyTo;

  /**
   * Should the member be notified if his message is denied by owner.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private String sendMessageDenyNotification;

  /**
   * Is the group listed in groups directory
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private String showInGroupDirectory;

  /**
   * Moderation level for messages detected as spam. Possible values are: ALLOW MODERATE
   * SILENTLY_MODERATE REJECT
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private String spamModerationLevel;

  /**
   * Permissions to invite members. Possbile values are: ALL_MEMBERS_CAN_INVITE
   * ALL_MANAGERS_CAN_INVITE
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private String whoCanInvite;

  /**
   * Permissions to join the group. Possible values are: ANYONE_CAN_JOIN ALL_IN_DOMAIN_CAN_JOIN
   * INVITED_CAN_JOIN CAN_REQUEST_TO_JOIN
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private String whoCanJoin;

  /**
   * Permissions to post messages to the group. Possible values are: NONE_CAN_POST
   * ALL_MANAGERS_CAN_POST ALL_MEMBERS_CAN_POST ALL_IN_DOMAIN_CAN_POST ANYONE_CAN_POST
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private String whoCanPostMessage;

  /**
   * Permissions to view group. Possbile values are: ANYONE_CAN_VIEW ALL_IN_DOMAIN_CAN_VIEW
   * ALL_MEMBERS_CAN_VIEW ALL_MANAGERS_CAN_VIEW
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private String whoCanViewGroup;

  /**
   * Permissions to view membership. Possbile values are: ALL_IN_DOMAIN_CAN_VIEW
   * ALL_MEMBERS_CAN_VIEW ALL_MANAGERS_CAN_VIEW
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private String whoCanViewMembership;

  /**
   * Are external members allowed to join the group.
   * The value returned may be {@code null}.
   */
  public String getAllowExternalMembers() {
    return allowExternalMembers;
  }

  /**
   * Are external members allowed to join the group.
   * The value set may be {@code null}.
   */
  public Groups setAllowExternalMembers(String allowExternalMembers) {
    this.allowExternalMembers = allowExternalMembers;
    return this;
  }

  /**
   * Is google allowed to contact admins.
   * The value returned may be {@code null}.
   */
  public String getAllowGoogleCommunication() {
    return allowGoogleCommunication;
  }

  /**
   * Is google allowed to contact admins.
   * The value set may be {@code null}.
   */
  public Groups setAllowGoogleCommunication(String allowGoogleCommunication) {
    this.allowGoogleCommunication = allowGoogleCommunication;
    return this;
  }

  /**
   * If posting from web is allowed.
   * The value returned may be {@code null}.
   */
  public String getAllowWebPosting() {
    return allowWebPosting;
  }

  /**
   * If posting from web is allowed.
   * The value set may be {@code null}.
   */
  public Groups setAllowWebPosting(String allowWebPosting) {
    this.allowWebPosting = allowWebPosting;
    return this;
  }

  /**
   * If the group is archive only
   * The value returned may be {@code null}.
   */
  public String getArchiveOnly() {
    return archiveOnly;
  }

  /**
   * If the group is archive only
   * The value set may be {@code null}.
   */
  public Groups setArchiveOnly(String archiveOnly) {
    this.archiveOnly = archiveOnly;
    return this;
  }

  /**
   * Default email to which reply to any message should go.
   * The value returned may be {@code null}.
   */
  public String getCustomReplyTo() {
    return customReplyTo;
  }

  /**
   * Default email to which reply to any message should go.
   * The value set may be {@code null}.
   */
  public Groups setCustomReplyTo(String customReplyTo) {
    this.customReplyTo = customReplyTo;
    return this;
  }

  /**
   * Default message deny notification message
   * The value returned may be {@code null}.
   */
  public String getDefaultMessageDenyNotificationText() {
    return defaultMessageDenyNotificationText;
  }

  /**
   * Default message deny notification message
   * The value set may be {@code null}.
   */
  public Groups setDefaultMessageDenyNotificationText(String defaultMessageDenyNotificationText) {
    this.defaultMessageDenyNotificationText = defaultMessageDenyNotificationText;
    return this;
  }

  /**
   * Description of the group
   * The value returned may be {@code null}.
   */
  public String getDescription() {
    return description;
  }

  /**
   * Description of the group
   * The value set may be {@code null}.
   */
  public Groups setDescription(String description) {
    this.description = description;
    return this;
  }

  /**
   * Email id of the group
   * The value returned may be {@code null}.
   */
  public String getEmail() {
    return email;
  }

  /**
   * Email id of the group
   * The value set may be {@code null}.
   */
  public Groups setEmail(String email) {
    this.email = email;
    return this;
  }

  /**
   * If this groups should be included in global address list or not.
   * The value returned may be {@code null}.
   */
  public String getIncludeInGlobalAddressList() {
    return includeInGlobalAddressList;
  }

  /**
   * If this groups should be included in global address list or not.
   * The value set may be {@code null}.
   */
  public Groups setIncludeInGlobalAddressList(String includeInGlobalAddressList) {
    this.includeInGlobalAddressList = includeInGlobalAddressList;
    return this;
  }

  /**
   * If the contents of the group are archived.
   * The value returned may be {@code null}.
   */
  public String getIsArchived() {
    return isArchived;
  }

  /**
   * If the contents of the group are archived.
   * The value set may be {@code null}.
   */
  public Groups setIsArchived(String isArchived) {
    this.isArchived = isArchived;
    return this;
  }

  /**
   * The type of the resource.
   * The value returned may be {@code null}.
   */
  public String getKind() {
    return kind;
  }

  /**
   * The type of the resource.
   * The value set may be {@code null}.
   */
  public Groups setKind(String kind) {
    this.kind = kind;
    return this;
  }

  /**
   * Maximum message size allowed.
   * The value returned may be {@code null}.
   */
  public Integer getMaxMessageBytes() {
    return maxMessageBytes;
  }

  /**
   * Maximum message size allowed.
   * The value set may be {@code null}.
   */
  public Groups setMaxMessageBytes(Integer maxMessageBytes) {
    this.maxMessageBytes = maxMessageBytes;
    return this;
  }

  /**
   * Can members post using the group email address.
   * The value returned may be {@code null}.
   */
  public String getMembersCanPostAsTheGroup() {
    return membersCanPostAsTheGroup;
  }

  /**
   * Can members post using the group email address.
   * The value set may be {@code null}.
   */
  public Groups setMembersCanPostAsTheGroup(String membersCanPostAsTheGroup) {
    this.membersCanPostAsTheGroup = membersCanPostAsTheGroup;
    return this;
  }

  /**
   * Default message display font. Possible values are: DEFAULT_FONT FIXED_WIDTH_FONT
   * The value returned may be {@code null}.
   */
  public String getMessageDisplayFont() {
    return messageDisplayFont;
  }

  /**
   * Default message display font. Possible values are: DEFAULT_FONT FIXED_WIDTH_FONT
   * The value set may be {@code null}.
   */
  public Groups setMessageDisplayFont(String messageDisplayFont) {
    this.messageDisplayFont = messageDisplayFont;
    return this;
  }

  /**
   * Moderation level for messages. Possible values are: MODERATE_ALL_MESSAGES MODERATE_NON_MEMBERS
   * MODERATE_NEW_MEMBERS MODERATE_NONE
   * The value returned may be {@code null}.
   */
  public String getMessageModerationLevel() {
    return messageModerationLevel;
  }

  /**
   * Moderation level for messages. Possible values are: MODERATE_ALL_MESSAGES MODERATE_NON_MEMBERS
   * MODERATE_NEW_MEMBERS MODERATE_NONE
   * The value set may be {@code null}.
   */
  public Groups setMessageModerationLevel(String messageModerationLevel) {
    this.messageModerationLevel = messageModerationLevel;
    return this;
  }

  /**
   * Name of the Group
   * The value returned may be {@code null}.
   */
  public String getName() {
    return name;
  }

  /**
   * Name of the Group
   * The value set may be {@code null}.
   */
  public Groups setName(String name) {
    this.name = name;
    return this;
  }

  /**
   * Primary language for the group.
   * The value returned may be {@code null}.
   */
  public String getPrimaryLanguage() {
    return primaryLanguage;
  }

  /**
   * Primary language for the group.
   * The value set may be {@code null}.
   */
  public Groups setPrimaryLanguage(String primaryLanguage) {
    this.primaryLanguage = primaryLanguage;
    return this;
  }

  /**
   * Whome should the default reply to a message go to. Possible values are: REPLY_TO_CUSTOM
   * REPLY_TO_SENDER REPLY_TO_LIST REPLY_TO_OWNER REPLY_TO_IGNORE REPLY_TO_MANAGERS
   * The value returned may be {@code null}.
   */
  public String getReplyTo() {
    return replyTo;
  }

  /**
   * Whome should the default reply to a message go to. Possible values are: REPLY_TO_CUSTOM
   * REPLY_TO_SENDER REPLY_TO_LIST REPLY_TO_OWNER REPLY_TO_IGNORE REPLY_TO_MANAGERS
   * The value set may be {@code null}.
   */
  public Groups setReplyTo(String replyTo) {
    this.replyTo = replyTo;
    return this;
  }

  /**
   * Should the member be notified if his message is denied by owner.
   * The value returned may be {@code null}.
   */
  public String getSendMessageDenyNotification() {
    return sendMessageDenyNotification;
  }

  /**
   * Should the member be notified if his message is denied by owner.
   * The value set may be {@code null}.
   */
  public Groups setSendMessageDenyNotification(String sendMessageDenyNotification) {
    this.sendMessageDenyNotification = sendMessageDenyNotification;
    return this;
  }

  /**
   * Is the group listed in groups directory
   * The value returned may be {@code null}.
   */
  public String getShowInGroupDirectory() {
    return showInGroupDirectory;
  }

  /**
   * Is the group listed in groups directory
   * The value set may be {@code null}.
   */
  public Groups setShowInGroupDirectory(String showInGroupDirectory) {
    this.showInGroupDirectory = showInGroupDirectory;
    return this;
  }

  /**
   * Moderation level for messages detected as spam. Possible values are: ALLOW MODERATE
   * SILENTLY_MODERATE REJECT
   * The value returned may be {@code null}.
   */
  public String getSpamModerationLevel() {
    return spamModerationLevel;
  }

  /**
   * Moderation level for messages detected as spam. Possible values are: ALLOW MODERATE
   * SILENTLY_MODERATE REJECT
   * The value set may be {@code null}.
   */
  public Groups setSpamModerationLevel(String spamModerationLevel) {
    this.spamModerationLevel = spamModerationLevel;
    return this;
  }

  /**
   * Permissions to invite members. Possbile values are: ALL_MEMBERS_CAN_INVITE
   * ALL_MANAGERS_CAN_INVITE
   * The value returned may be {@code null}.
   */
  public String getWhoCanInvite() {
    return whoCanInvite;
  }

  /**
   * Permissions to invite members. Possbile values are: ALL_MEMBERS_CAN_INVITE
   * ALL_MANAGERS_CAN_INVITE
   * The value set may be {@code null}.
   */
  public Groups setWhoCanInvite(String whoCanInvite) {
    this.whoCanInvite = whoCanInvite;
    return this;
  }

  /**
   * Permissions to join the group. Possible values are: ANYONE_CAN_JOIN ALL_IN_DOMAIN_CAN_JOIN
   * INVITED_CAN_JOIN CAN_REQUEST_TO_JOIN
   * The value returned may be {@code null}.
   */
  public String getWhoCanJoin() {
    return whoCanJoin;
  }

  /**
   * Permissions to join the group. Possible values are: ANYONE_CAN_JOIN ALL_IN_DOMAIN_CAN_JOIN
   * INVITED_CAN_JOIN CAN_REQUEST_TO_JOIN
   * The value set may be {@code null}.
   */
  public Groups setWhoCanJoin(String whoCanJoin) {
    this.whoCanJoin = whoCanJoin;
    return this;
  }

  /**
   * Permissions to post messages to the group. Possible values are: NONE_CAN_POST
   * ALL_MANAGERS_CAN_POST ALL_MEMBERS_CAN_POST ALL_IN_DOMAIN_CAN_POST ANYONE_CAN_POST
   * The value returned may be {@code null}.
   */
  public String getWhoCanPostMessage() {
    return whoCanPostMessage;
  }

  /**
   * Permissions to post messages to the group. Possible values are: NONE_CAN_POST
   * ALL_MANAGERS_CAN_POST ALL_MEMBERS_CAN_POST ALL_IN_DOMAIN_CAN_POST ANYONE_CAN_POST
   * The value set may be {@code null}.
   */
  public Groups setWhoCanPostMessage(String whoCanPostMessage) {
    this.whoCanPostMessage = whoCanPostMessage;
    return this;
  }

  /**
   * Permissions to view group. Possbile values are: ANYONE_CAN_VIEW ALL_IN_DOMAIN_CAN_VIEW
   * ALL_MEMBERS_CAN_VIEW ALL_MANAGERS_CAN_VIEW
   * The value returned may be {@code null}.
   */
  public String getWhoCanViewGroup() {
    return whoCanViewGroup;
  }

  /**
   * Permissions to view group. Possbile values are: ANYONE_CAN_VIEW ALL_IN_DOMAIN_CAN_VIEW
   * ALL_MEMBERS_CAN_VIEW ALL_MANAGERS_CAN_VIEW
   * The value set may be {@code null}.
   */
  public Groups setWhoCanViewGroup(String whoCanViewGroup) {
    this.whoCanViewGroup = whoCanViewGroup;
    return this;
  }

  /**
   * Permissions to view membership. Possbile values are: ALL_IN_DOMAIN_CAN_VIEW
   * ALL_MEMBERS_CAN_VIEW ALL_MANAGERS_CAN_VIEW
   * The value returned may be {@code null}.
   */
  public String getWhoCanViewMembership() {
    return whoCanViewMembership;
  }

  /**
   * Permissions to view membership. Possbile values are: ALL_IN_DOMAIN_CAN_VIEW
   * ALL_MEMBERS_CAN_VIEW ALL_MANAGERS_CAN_VIEW
   * The value set may be {@code null}.
   */
  public Groups setWhoCanViewMembership(String whoCanViewMembership) {
    this.whoCanViewMembership = whoCanViewMembership;
    return this;
  }

}
